
hauteur = 150;
diamHaut = 95;
diamBas = 115;
ep = 0.5;
angleX = 10;
angleY = 5;
decalZ = 10;

// dimensions du support rectangulaire pour l'électronique
    yInt = 24.3;
    xInt = 71;
    zInt = 70;

    epAimant = 3;
    diaAimant = 19.9;
   
  diaElecHoleInt = 8; 


module blocageInferieur() {
    intersection() {
        bodyExt();
        union() {
            rotate([angleX, angleY, 0])  translate([-diamBas/2,-1,0]) cube([diamBas/4,9,decalZ-1.5]);
            rotate([angleX, angleY, 0])  translate([diamBas/4,-1,0]) cube([diamBas/4,9,decalZ-1.5]);
            rotate([angleX, angleY, 0])  translate([-diamBas/2,-62,0]) cube([diamBas,9,decalZ-1.5]);
        }
    }
}


module subbody(dh, db, h, decal) {
    n = 10;
    d = 3.14*diamBas / n * 0.20 ;
    rSphere = dh/2;

    difference() {
        rotate([angleX, angleY, 0]) {
            cylinder(d1=db, d2=dh, h - dh/2);
            translate([0, 0, h - rSphere ]) scale([1,1,0.8])  sphere(r=rSphere-decal); 
        }
        translate([-db, -decal, -h]) cube([2*db, 2*db, 2*h]);
    }
}

module bodyExt() {
   subbody(diamHaut, diamBas, hauteur, 0);
}
module bodyInt() {
   subbody(diamHaut-2, diamBas-2, hauteur-1, 1);
}

module body() {
    rotate([-angleX, -angleY, 0]) {
        difference() {
           bodyExt();
           bodyInt();
           electricHole(diaElecHoleInt); 
           supportAimantsMoins();
        }
       supportAimantsPlus();
        difference() {
            electricHole(diaElecHoleInt+2);      
            translate([-100, 0, 0]) cube([200, 200, hauteur]);
            electricHole(diaElecHoleInt); 
        }
        blocageInferieur();
    }
}    

module subEyes() {
    dEyes = diamBas/4;
    decalage = dEyes/2.2;
    
    translate([decalage, 0, 0])  difference() {
       scale([1.2,1,0.8]) sphere(d=dEyes); 
       translate([0, diamBas/2, 0 ]) rotate([89,0,2])  cylinder(d=dEyes/2.3, h=diamBas);
    }
    translate([-decalage, 0, 0]) difference() {
        scale([1.3,1,0.8])  sphere(d=dEyes); 
       translate([0, diamBas/2, 0 ]) rotate([90,0,-3])  cylinder(d=dEyes/2.5, h=diamBas);
    }
}

module pinEye() {
   rotate([-90, 0, 0])  cylinder(d=diamBas/15, h=diamBas/5);
}

module eyes() {
    difference() {
        translate([0, -diamHaut * 0.4, hauteur - diamHaut/2]) subEyes();
#        rotate([-angleX, -angleY, 0])  bodyExt();
    }
}


module electricHole(dia) {
    translate([diamHaut/3, 0, hauteur * 0.6]) rotate([55, 0, 0]) translate([0,0,-10]) cylinder(d=dia, h=25);
}


module supportAimantPlus() {
    difference() {
        union() {
            translate([0,-2*epAimant-3,diaAimant/2]) cube([diaAimant+2, epAimant+2, 2+diaAimant/2]);
            translate([1+diaAimant/2, -epAimant-1, 1+diaAimant/2]) rotate([90,0,0]) cylinder(d1=diaAimant+8, d2=diaAimant+2, h=epAimant+2);
            
            translate([1+diaAimant/2, 0, 1+diaAimant/2]) rotate([90,0,0]) cylinder(d1=diaAimant+13, d2=diaAimant+7,  h=epAimant+2);
            
            
        }
       translate([1,-2*epAimant-2,diaAimant/2]) cube([diaAimant, epAimant, 6+diaAimant/2]);
        translate([diaAimant/2-3,-2*epAimant-2,-2]) cube([8, epAimant, 3+diaAimant/2]);
        translate([1+diaAimant/2, -epAimant-2, 1+diaAimant/2]) rotate([90,0,0]) cylinder(d1=diaAimant+6, d2=diaAimant, h=epAimant);

        translate([1+diaAimant/2, 0, 1+diaAimant/2]) rotate([90,0,0]) cylinder(d1=diaAimant+11, d2=diaAimant+5,  h=epAimant+1);
    }
}

module supportAimantMoins() {  
   translate([1+diaAimant/2, 0, 1+diaAimant/2]) rotate([90,0,0]) cylinder(d1=diaAimant+4, d2=diaAimant,  h=epAimant+1);
}

module supportAimantsPlus() {
  translate([0,0,hauteur * 0.55]) supportAimantPlus();  
  translate([0,0,hauteur * 0.16]) supportAimantPlus();  
}

module supportAimantsMoins() {
  translate([0,0,hauteur * 0.55]) supportAimantMoins();  
  translate([0,0,hauteur * 0.16]) supportAimantMoins();  
}


module supportElectronique() {
      
    
    translate([3,-4,0]) difference() {
        union() {
            // support inférieur
            translate([-diamBas, -diamBas, decalZ]) cube([2*diamBas, diamBas*2, 1]);

            // conduit de sortie
            translate([diamBas/2 - 15, -10, decalZ + 2*ep]) cylinder(d=13, h=decalZ + 2*ep);

            // conduit d'entrée
            difference() {
                translate([-40+6,     -yInt-3*ep+12,        decalZ+ep])    cube([35+2*ep, 12+2*ep,    7]);
                translate([-40+ep+6,  -yInt-2*ep+12,     decalZ+ep])  cube([35,    12,         7+2*ep]);
            }         
            // support électronique
            translate([-40, -yInt-3*ep, decalZ]) {
                difference() {
                    union() {
                        cube([xInt+2*ep, yInt+2*ep, zInt+ep]); 
                        translate([-ep, -ep, 0]) cube([xInt+4*ep, yInt+4*ep, 8*ep]); 
                        translate([-2*ep, -2*ep, 0]) cube([xInt+6*ep, yInt+6*ep, 5*ep]); 
                    }
                    translate([ep, ep, ep]) cube([xInt, yInt, zInt+ep]); 
                }
            }
            
            // support pour capteur température
            translate([0, -35, decalZ]) {
                difference() {
                    rotate([0,90,0]) cylinder(d=16, h=16);
                    translate([-1,0,0]) rotate([0,90,0]) cylinder(d=14, h=16);
                    translate([0,0,-20]) cylinder(d=50, h=20);
                }
            }
        }        
        // trou de sortie
        translate([diamBas/2 - 15, -10, 0]) cylinder(d=9, h=decalZ + 2*ep + 151);

        // trou d'entrée
        translate([-40+ep+6,  -yInt-2*ep+12,    decalZ -2])  cube([35,    12,         7]);



        // trou pour capteur température
        translate([0, -35, decalZ-1])  cube([7,5,2]); 
        translate([8, -35, decalZ-1])  cube([7,5,2]); 
        translate([0, -35-6, decalZ-1])  cube([7,5,2]); 
        translate([8, -35-6, decalZ-1])  cube([7,5,2]); 
    }  
}

module supportInferieur() {
    decalZl = decalZ - 1.5;
    
    intersection() {
         rotate([-angleX, -angleY, 0])  bodyInt();
        difference() {
            translate([-diamBas, -diamBas, decalZl]) cube([2*diamBas, diamBas, 1]);            
            translate([3,-4,0]) {
                // trou de sortie
                translate([diamBas/2 - 15, -10, 0]) cylinder(d=9, h=decalZ + 2*ep + 151);

                // trou d'entrée
                translate([-40+ep+6,  -yInt-2*ep+12,    decalZ -2])  cube([35,    12,         7]);

                // trou pour capteur température
                translate([0, -35, 0])  cube([7,5,20]); 
                translate([8, -35, 0])  cube([7,5,20]); 
                translate([0, -35-6, 0])  cube([7,5,20]); 
                translate([8, -35-6, 0])  cube([7,5,20]); 
             }
        }
    }
}

module internal() {
    intersection() {
        rotate([-angleX, -angleY, 0]) bodyInt();
        /*rotate([angleX, angleY, 0])*/ supportElectronique();
    }
}





body();
internal();
supportInferieur();
